import React, { FC, Children } from 'react'
import { hasPrivilege } from './PermissionsManager'
import { isStr } from 'sunny-js/util/string'

interface PrivilegeProps {
  // 资源名称，一般不用传递，如果默认值location.pathname无法满足，请传入
  resource?: string,
  // 特权键名，通常是由 {@link ModuleInterfaces.privilegeProp} 决定的
  key?: string
}
export const Privilege: FC<PrivilegeProps> = ({
  key,
  resource,
  children
}) => {
  // 尝试自动获取文本作为key
  let text
  // @ts-ignore
  const childProps = children.props
  if (Children.count(children) == 1 && childProps) {
    text = childProps.children
    text = isStr(text) && text.trim()
  }
  return <>{hasPrivilege(key || text, resource) ? children : null}</>
}
